<?php
if(!function_exists("display_news")) //this step should happen only once per page
{
	$_bitowl["temp"] = explode("&", $_SERVER["QUERY_STRING"]); //get all variables from url
	$_bitowl["temp2"] = count($_bitowl["temp"]);
	for($i = 0;$i < $_bitowl["temp2"];$i++) //strip certain ones
	{
		if(strpos($_bitowl["temp"][$i], "newspage=") !== false)
		{
			unset($_bitowl["temp"][$i]);
		}
		elseif(strpos($_bitowl["temp"][$i], "category=") !== false)
		{
			unset($_bitowl["temp"][$i]);
		}
	}
	$_bitowl["temp"] = implode("&amp;", $_bitowl["temp"])."&amp;";
	$_SERVER["QUERY_STRING"] = $_bitowl["temp"];
	require "$path/news.php";
	function category_id2name($cid) //converts category id to name
	{
		global $categories;
		for($i = 0;$i < count($categories);$i++)
		{
			if($categories[$i]["id"] == $cid)
			{
				return $categories[$i]["name"];
			}
		}
	}
	function get_category_news($category) //this processes the news into by category news used in display_news()
	{
		global $news, $categories, $_bitowl;
		for($i = 0;$i < count($news);$i++)
		{
			if(strpos(implode(",", $news[$i]["categories"]), $category) !== false)
			{
				$cat_news[] = $news[$i];
			}
		}
		$cat_news = isset($cat_news) ? $cat_news : array();
		return $cat_news;
	}
	function display_news($category = -1, $page = 1) //this decides what post to display and sets the news var to category
	{
		global $news, $categories, $_bitowl;
		if($category != -1)
		{
			$news = get_category_news($category);
		}
		$start = (count($news)-1)-($_bitowl["news"]["itemperpage"]*($page-1));
		$end = $start - $_bitowl["news"]["itemperpage"] + 1;
		if($end < 0)
		{
			$end = 0;
		}
		if($_bitowl["news"]["itemperpage"] <= 0)
		{
			$start = count($news)-1;
			$end = 0;
		}
		for($i = $start;$i >= $end;$i--)
		{
			if(($category == -1) || (strpos(implode(",", $news[$i]["categories"]), $category) !== false))
			{
				display_news_item($i);
			}
		}
	}
	function display_news_item($id) //this displays the post
	{
		global $news, $categories, $_bitowl;
		$title = stripslashes($news[$id]["title"]);
		$message = stripslashes($news[$id]["message"]);
		$date = date($_bitowl["news"]["date"], $news[$id]["date"]);
		$author = $news[$id]["author"];
		for($i = 0;$i < count($news[$id]["categories"]);$i++)
		{
			$news[$id]["categories"][$i] = "<a href=\"?".$_SERVER["QUERY_STRING"]."category=".$news[$id]["categories"][$i]."\">".category_id2name($news[$id]["categories"][$i])."</a>";
		}
		$news_categories = implode(", ", $news[$id]["categories"]);
		$cat_avatar = $news[$id]["categories"][0];
		for($i = 0;$i < count($categories);$i++)
		{
			if($categories[$i]["id"] == $cat_avatar)
			{
				$cat_avatar = $categories[$i]["avatar"];
				if($cat_avatar === false)
				{
					$cat_avatar = "&nbsp;";
				}
				else
				{
					$cat_avatar = "<img src=\"$cat_avatar\" alt=\"&nbsp;\" />";
				}
				break;
			}
		}
		$data = array("author" => $author, "categories" => $news_categories, "date" => $date, "title" => $title, "message" => $message);
		echo parse_template("news-item.html", $data);
	}
	function display_page_nav($current_page) // < 1 2 3 > etc part
	{
		global $news, $categories, $_bitowl;
		$pages = ceil(count($news)/$_bitowl["news"]["itemperpage"]);
		$prev_page = $current_page - 1;
		$next_page = $current_page + 1;
		echo "<p style=\"text-align: center\">";
		if($prev_page != 0)
		{
			echo "<a href=\"?".$_SERVER["QUERY_STRING"]."newspage=".$prev_page."\">&lt;</a> ";
		}
		for($i = 1;$i <= $pages;$i++)
		{
			if($i != $current_page)
			{
				echo "<a href=\"?".$_SERVER["QUERY_STRING"]."newspage=$i\">$i</a>";
			}
			else
			{
				echo $i;
			}
			if($i < $pages)
			{
				echo " ";
			}
		}
		if($next_page != $pages+1)
		{
			echo " <a href=\"?".$_SERVER["QUERY_STRING"]."newspage=".$next_page."\">&gt;</a> ";
		}
		echo "</p>";
	}
}
else //reset the db vars
{
	unset($news, $categories);
	require "$path/news.php";
}
$_GET["category"] = isset($_GET["category"]) ? ''.$_GET["category"] : -1; //''. makes this work
$_GET["newspage"] = isset($_GET["newspage"]) ? $_GET["newspage"] : 1;
display_news($_GET["category"], $_GET["newspage"]);
if($_bitowl["news"]["pages"])
{
	display_page_nav($_GET["newspage"]);
}
?>